#ifndef FILE_OBJECT_H
#define FILE_OBJECT_H

#ifndef SDL_Surface
	#include "SDL/SDL.h"
#endif

struct stFileObject { // logic object. combination of data from the map object information and the object file
	char id[4]; // holds the number for the relative object file. eg '003' for 003.obj
	struct coordinate start_point;
};

struct struct_object { // same as the file object, but also contain pointers to be list and surface for graphics
	char id[4]; // holds the number for the relative object file. eg '003' for 003.obj
	char name[20];
	char filename[50];						// graphic file used on it
	short int type;
	int timer;				// used as time for disapearing block
	int speed;				// used as speed for moving platform
	int limit;				// used as range (pixels) for moving platform, visible time for disapearing block
	int direction;			// used to check if moving away from oiginalpoint or moving to it
	int distance;
	int framesize_w;
	int framesize_h;
	int frame;				// indicates what is the used frame
	struct coordinate start_point;
	struct coordinate position;
	SDL_Surface *sprite;
	struct struct_object *next;
};




#endif // FILE_OBJECT_H
